#include <bits/stdc++.h>
using namespace std;

int main()
{
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

    int n,k;
    cin >> n >> k;
    string s;
    cin >> s;
    map<char,int> c;
    cout << 1 << ' ';
    c[s[0]]++;
    string x = "abcdefghijklmnopqrstuvwxyz";
    for(int i = 1;i < n;i++){
        c[s[i]]++;
        int mn = 200005;
        for(int j = 0;j < k;j++){
            mn = min(c[x[j]],mn);
        }
        cout << mn+1 << ' ';
    }

    return 0;
}